from .fangraphs_stats_base import FangraphsStatsBase


class FangraphsBattingStats(FangraphsStatsBase):
    COMMON                            = 'c'
    LINE_BREAK                        = '-1'
    NAME                              = '0'
    TEAM                              = '1'
    SEASON                            = '2'
    AGE                               = '3'
    G                                 = '4'
    GAMES                             = G
    AB                                = '5'
    AT_BATS                           = AB
    PA                                = '6'
    PLATE_APPEARANCES                 = PA
    H                                 = '7'
    HITS                              = H
    SINGLES                           = '8'  # 1B
    DOUBLES                           = '9'  # 2B
    TRIPLES                           = '10' # 3B
    HR                                = '11'
    HOME_RUNS                         = HR
    R                                 = '12'
    RUNS                              = R
    RBI                               = '13'
    BB                                = '14'
    WALKS                             = BB
    IBB                               = '15'
    INTENTIONAL_WALKS                 = IBB
    SO                                = '16'
    STRIKE_OUTS                       = SO
    HBP                               = '17'
    HIT_BY_PITCH                      = HBP
    SF                                = '18'
    SACRIFICE_FLY                     = SF
    SH                                = '19'
    SACRIFICE_HIT                     = SH
    GDP                               = '20'
    GROUNDED_DOUBLE_PLAY              = GDP
    SB                                = '21'
    STOLEN_BASES                      = SB
    CS                                = '22'
    CAUGHT_STEALING                   = CS
    AVG                               = '23'
    BATTING_AVERAGE                   = AVG
    GB                                = '24'
    GROUND_BALLS                      = GB
    FB                                = '25'
    FLY_BALLS                         = FB
    LD                                = '26' # ?
    IFFB                              = '27' # ?
    PITCHES                           = '28'
    BALLS                             = '29'
    STRIKES                           = '30'
    IFH                               = '31' # ? INFIELD_HITS?
    BU                                = '32' # ?
    BUH                               = '33' # ?
    BB_PCT                            = '34' # BB%
    WALK_PERCENTAGE                   = BB_PCT
    K_PCT                             = '35' # K%
    STRIKE_PERCENTAGE                 = K_PCT
    BB_K                              = '36'
    WALKS_PER_STRIKOUT                = BB_K # BB/K
    OBP                               = '37'
    ON_BASE_PERCENTAGE                = OBP
    SLG                               = '38'
    SLUGGING                          = SLG
    OPS                               = '39'
    ON_BASE_PLUS_SLUGGING             = OPS
    ISO                               = '40'
    ISOLATED_POWER                    = ISO
    BABIP                             = '41'
    BATTING_AVERAGE_FOR_BALLS_IN_PLAY = BABIP
    GB_FB                             = '42' # GB/FB
    GROUND_BALLS_PER_FLY_BALL         = GB_FB
    LD_PCT                            = '43' # LD% ?
    GB_PCT                            = '44' # GB%
    GROUND_BALL_PERCENTAGE            = GB_PCT
    FB_PCT                            = '45'# FB%
    FLY_BALL_PERCENTAGE               = FB_PCT
    IFFB_PCT                          = '46' # IFFB% ?
    HR_FB                             = '47' # HR/FB
    HOME_RUNS_PER_FLY_BALL            = HR_FB
    IFH_PCT                           = '48' # IFH%
    INFIELD_HIT_PERCENTAGE            = IFH_PCT
    BUH_PCT                           = '49' # BUH% ?
    WOBA                              = '50'
    WEIGHTED_ON_BASE_AVERAGE          = WOBA
    WRAA                              = '51' # ?
    WRC                               = '52'
    WEIGHTED_RUNS_CREATED             = WRC
    BATTING                           = '53' # BATTING ?
    BAT                               = BATTING
    FIELDING                          = '54' # ?
    FLD                               = FIELDING
    REPLACEMENT                       = '55' # ?
    REP                               = REPLACEMENT
    POSITIONAL                        = '56' # ?
    POS                               = POSITIONAL
    RAR                               = '57'
    RUNS_ABOVE_REPLACEMENT            = RAR
    WAR                               = '58'
    WINS_ABOVE_REPLACEMENT            = WAR
    DOLLARS                           = '59'
    DOL                               = DOLLARS
    DOLLARS_VALUE                     = DOLLARS
    SPD                               = '60' # SPEED?
    WRC_PLUS                          = '61' # wRC+
    WEIGHTED_RUNS_CREATED_PLUS        = WRC_PLUS
    WPA                               = '62'
    WIN_PROBABILITY_ADDED             = WPA
    NEGATIVE_WPA                      = '63' # -WPA
    NEGATIVE_WIN_PROBABILITY_ADDED    = NEGATIVE_WPA
    POSITIVE_WPA                      = '64' # +WPA
    POSITIVE_WIN_PROBABILITY_ADDED    = POSITIVE_WPA
    RE24                              = '65' # ?
    REW                               = '66' # ?
    PLI                               = '67' # ?
    PHLI                              = '68' # ?
    PH                                = '69' # ?
    WPA_LI                            = '70' # WPA/LI ?
    CLUTCH                            = '71'
    FB_PCT_PITCH                      = '72' # FB% (Pitch) ? Not sure the difference between this and 45
    FB_PCT_2                          = FB_PCT_PITCH
    FBV                               = '73' # ?
    SL_PCT                            = '74' # SL% ?
    SLV                               = '75' # ?
    CT_PCT                            = '76' # CT% ?
    CTV                               = '77'
    CB_PCT                            = '78' # CB% ?
    CBV                               = '79' # ?
    CH_PCT                            = '80' # CH% ?
    CHV                               = '81' # ?
    SF_PCT                            = '82' # SF% ?
    SFV                               = '83' # ?
    KN_PCT                            = '84' # KN% ?
    KNV                               = '85' # ?
    XX_PCT                            = '86' # XX% ?
    PO_PCT                            = '87' # PO% ?
    WFB                               = '88' # ?
    WSL                               = '89' # ?
    WCT                               = '90' # ?
    WCB                               = '91' # ?
    WCH                               = '92' # ?
    WSF                               = '93' # ?
    WKN                               = '94' # ?
    WFB_C                             = '95' # wFB/C ?
    WSL_C                             = '96' # wSL/C ?
    WCT_C                             = '97' # wCT/C ?
    WCB_C                             = '98' # wCB/C ?
    WCH_C                             = '99' # wCH/C ?
    WSF_C                             = '100' # wSF/C ?
    WKN_C                             = '101' # wKN/C ?
    O_SWING_PCT                       = '102' # O-Swing% ?
    OSWING_PCT                        = O_SWING_PCT
    Z_SWING_PCT                       = '103' # Z-Swing% ?
    ZSWING_PCT                        = Z_SWING_PCT
    SWING_PCT                         = '104' # Swing% ?
    O_CONTACT_PCT                     = '105' # O-Contact% ?
    OCONTACT_PCT                      = O_CONTACT_PCT
    Z_CONTACT_PCT                     = '106' # Z-Contact% ?
    ZCONTACT_PCT                      = Z_CONTACT_PCT
    CONTACT_PCT                       = '107' # Contact% ?
    ZONE_PCT                          = '108' # Zone% ?
    F_STRIKE_PCT                      = '109' # F-Strike% ?
    FSTRIKE_PCT                       = F_STRIKE_PCT
    SWSTR_PCT                         = '110' # SwStr% SWINGING_STRIKE_PERCENTAGE?
    BASE_RUNNING                      = '111' # Base Running ?
    BSR                               = BASE_RUNNING
    FA_PCT_SC                         = '112' # 'FA% (sc)' ?
    FT_PCT_SC                         = '113' # 'FT% (sc)' ?
    FC_PCT_SC                         = '114' # 'FC% (sc)' ?
    FS_PCT_SC                         = '115' # 'FS% (sc)' ?
    FO_PCT_SC                         = '116' # 'FO% (sc)' ?
    SI_PCT_SC                         = '117' # 'SI% (sc)' ?
    SL_PCT_SC                         = '118' # 'SL% (sc)' ?
    CU_PCT_SC                         = '119' # 'CU% (sc)' ?
    KC_PCT_SC                         = '120' # 'KC% (sc)' ?
    EP_PCT_SC                         = '121' # 'EP% (sc)' ?
    CH_PCT_SC                         = '122' # 'CH% (sc)' ?
    SC_PCT_SC                         = '123' # 'SC% (sc)' ?
    KN_PCT_SC                         = '124' # 'KN% (sc)' ?
    UN_PCT_SC                         = '125' # 'UN% (sc)' ?
    VFA_SC                            = '126' # 'vFA (sc)' ?
    VFT_SC                            = '127' # 'vFT (sc)' ?
    VFC_SC                            = '128' # 'vFC (sc)' ?
    VFS_SC                            = '129' # 'vFS (sc)' ?
    VFO_SC                            = '130' # 'vFO (sc)' ?
    VSI_SC                            = '131' # 'vSI (sc)' ?
    VSL_SC                            = '132' # 'vSL (sc)' ?
    VCU_SC                            = '133' # 'vCU (sc)' ?
    VKC_SC                            = '134' # 'vKC (sc)' ?
    VEP_SC                            = '135' # 'vEP (sc)' ?
    VCH_SC                            = '136' # 'vCH (sc)' ?
    VSC_SC                            = '137' # 'vSC (sc)' ?
    VKN_SC                            = '138' # 'vKN (sc)' ?
    FA_X_SC                           = '139' # 'FA-X (sc)' ?
    FT_X_SC                           = '140' # 'FT-X (sc)' ?
    FC_X_SC                           = '141' # 'FC-X (sc)' ?
    FS_X_SC                           = '142' # 'FS-X (sc)' ?
    FO_X_SC                           = '143' # 'FO-X (sc)' ?
    SI_X_SC                           = '144' # 'SI-X (sc)' ?
    SL_X_SC                           = '145' # 'SL-X (sc)' ?
    CU_X_SC                           = '146' # 'CU-X (sc)' ?
    KC_X_SC                           = '147' # 'KC-X (sc)' ?
    EP_X_SC                           = '148' # 'EP-X (sc)' ?
    CH_X_SC                           = '149' # 'CG-X (sc)' ?
    SC_X_SC                           = '150' # 'SC-X (sc)' ?
    KN_X_SC                           = '151' # 'KN-X (sc)' ?
    FA_Z_SC                           = '152' # 'FA-Z (sc)' ?
    FT_Z_SC                           = '153' # 'FT-Z (sc)' ?
    FC_Z_SC                           = '154' # 'FC-Z (sc)' ?
    FS_Z_SC                           = '155' # 'FS-Z (sc)' ?
    FO_Z_SC                           = '156' # 'FO-Z (sc)' ?
    SI_Z_SC                           = '157' # 'SI-Z (sc)' ?
    SL_Z_SC                           = '158' # 'SL-Z (sc)' ?
    CU_Z_SC                           = '159' # 'CU-Z (sc)' ?
    KC_Z_SC                           = '160' # 'KC-Z (sc)' ?
    EP_Z_SC                           = '161' # 'EP-Z (sc)' ?
    CH_Z_SC                           = '162' # 'CH-Z (sc)' ?
    SC_Z_SC                           = '163' # 'SC-Z (sc)' ?
    KN_Z_SC                           = '164' # 'KN-Z (sc)' ?
    WFA_SC                            = '165' # 'wFA (sc)' ?
    WFT_SC                            = '166' # 'wFT (sc)' ?
    WFC_SC                            = '167' # 'wFC (sc)' ?
    WFS_SC                            = '168' # 'wFS (sc)' ?
    WFO_SC                            = '169' # 'wFO (sc)' ?
    WSI_SC                            = '170' # 'wSI (sc)' ?
    WSL_SC                            = '171' # 'wSL (sc)' ?
    WCU_SC                            = '172' # 'wCU (sc)' ?
    WKC_SC                            = '173' # 'wKC (sc)' ?
    WEP_SC                            = '174' # 'wEP (sc)' ?
    WCH_SC                            = '175' # 'wCH (sc)' ?
    WSC_SC                            = '176' # 'wSC (sc)' ?
    WKN_SC                            = '177' # 'wKN (sc)' ?
    WFA_C_SC                          = '178' # 'wFA/C (sc)' ?
    WFT_C_SC                          = '179' # 'wFT/C (sc)' ?
    WFC_C_SC                          = '180' # 'wFC/C (sc)' ?
    WFS_C_SC                          = '181' # 'wFS/C (sc)' ?
    WFO_C_SC                          = '182' # 'wFO/C (sc)' ?
    WSI_C_SC                          = '183' # 'wSI/C (sc)' ?
    WSL_C_SC                          = '184' # 'wSL/C (sc)' ?
    WCU_C_SC                          = '185' # 'wCU/C (sc)' ?
    WKC_C_SC                          = '186' # 'wKC/C (sc)' ?
    WEP_C_SC                          = '187' # 'wEP/C (sc)' ?
    WCH_C_SC                          = '188' # 'wCH/C (sc)' ?
    WSC_C_SC                          = '189' # 'wSC/C (sc)' ?
    WKN_C_SC                          = '190' # 'wKN/C (sc)' ?
    O_SWING_PCT_SC                    = '191' # 'O-Swing% (sc)' ?
    Z_SWING_PCT_SC                    = '192' # 'Z-Swing% (sc)' ?
    SWING_PCT_SC                      = '193' # 'Swing% (sc)' ?
    O_CONTACT_PCT_SC                  = '194' # 'O-Contact% (sc)' ?
    Z_CONTACT_PCT_SC                  = '195' # 'Z-Contact% (sc)' ?
    CONTACT_PCT_SC                    = '196' # 'Contact% (sc)' ?
    ZONE_PCT_SC                       = '197' # 'Zone% (sc)' ?
    PACE                              = '198' # ?
    DEFENSE                           = '199' # Defense ?
    DEF                               = DEFENSE
    WSB                               = '200' # ?
    UBR                               = '201' # ?
    AGE_RNG                           = '202' # 'Age Rng' ?
    OFFENSE                           = '203' # ?
    OFF                               = OFFENSE
    LEAGUE                            = '204' # ?
    LG                                = LEAGUE
    WGDP                              = '205'# wGDP ? WEIGHTED_GROUNDED_DOUBLE_PLAY?
    wGDP                              = WGDP
    PULL_PCT                          = '206' # Pull% ?
    CENT_PCT                          = '207' # Cent% ?
    OPPO_PCT                          = '208' # Oppo% ?
    SOFT_PCT                          = '209' # Soft% ?
    MED_PCT                           = '210' # Med% ?
    HARD_PCT                          = '211' # Hard% ?
    TTO_PCT                           = '212' # TTO% ?
    CH_PCT_PI                         = '213' # 'CH% (pi)' ?
    CS_PCT_PI                         = '214' # 'CS% (pi)' ?
    CU_PCT_PI                         = '215' # 'CU% (pi)' ?
    FA_PCT_PI                         = '216' # 'FA% (pi)' ?
    FC_PCT_PI                         = '217' # 'FC% (pi)' ?
    FS_PCT_PI                         = '218' # 'FS% (pi)' ?
    KN_PCT_PI                         = '219' # 'KN% (pi)' ?
    SB_PCT_PI                         = '220' # 'SB% (pi)' ?
    SI_PCT_PI                         = '221' # 'SI% (pi)' ?
    SL_PCT_PI                         = '222' # 'SL% (pi)' ?
    XX_PCT_PI                         = '223' # 'XX% (pi)' ?
    VCH_PI                            = '224' # 'vCH (pi)' ?
    VCS_PI                            = '225' # 'vCS (pi)' ?
    VCU_PI                            = '226' # 'vCU (pi)' ?
    VFA_PI                            = '227' # 'vFA (pi)' ?
    VFC_PI                            = '228' # 'vFC (pi)' ?
    VFS_PI                            = '229' # 'vFS (pi)' ?
    VKN_PI                            = '230' # 'vKN (pi)' ?
    VSB_PI                            = '231' # 'vSB (pi)' ?
    VSI_PI                            = '232' # 'vSI (pi)' ?
    VSL_PI                            = '233' # 'vSL (pi)' ?
    VXX_PI                            = '234' # 'vXX (pi)' ?
    CH_X_PI                           = '235' # 'CH-X (pi)' ?
    CS_X_PI                           = '236' # 'CS-X (pi)' ?
    CU_X_PI                           = '237' # 'CU-X (pi)' ?
    FA_X_PI                           = '238' # 'FA-X (pi)' ?
    FC_X_PI                           = '239' # 'FC-X (pi)' ?
    FS_X_PI                           = '240' # 'FS-X (pi)' ?
    KN_X_PI                           = '241' # 'KN-X (pi)' ?
    SB_X_PI                           = '242' # 'SB-X (pi)' ?
    SI_X_PI                           = '243' # 'SI-X (pi)' ?
    SL_X_PI                           = '244' # 'SL-X (pi)' ?
    XX_X_PI                           = '245' # 'XX-X (pi)' ?
    CH_Z_PI                           = '246' # 'CH-Z (pi)' ?
    CS_Z_PI                           = '247' # 'CS-Z (pi)' ?
    CU_Z_PI                           = '248' # 'CU-Z (pi)' ?
    FA_Z_PI                           = '249' # 'FA-Z (pi)' ?
    FC_Z_PI                           = '250' # 'FC-Z (pi)' ?
    FS_Z_PI                           = '251' # 'FS-Z (pi)' ?
    KN_Z_PI                           = '252' # 'KN-Z (pi)' ?
    SB_Z_PI                           = '253' # 'SB-Z (pi)' ?
    SI_Z_PI                           = '254' # 'SI-Z (pi)' ?
    SL_Z_PI                           = '255' # 'SL-Z (pi)' ?
    XX_Z_PI                           = '256' # 'XX-Z (pi)' ?
    WCH_PI                            = '257' # 'wCH (pi)' ?
    WCS_PI                            = '258' # 'wCS (pi)' ?
    WCU_PI                            = '259' # 'wCU (pi)' ?
    WFA_PI                            = '260' # 'wFA (pi)' ?
    WFC_PI                            = '261' # 'wFC (pi)' ?
    WFS_PI                            = '262' # 'wFS (pi)' ?
    WKN_PI                            = '263' # 'wKN (pi)' ?
    WSB_PI                            = '264' # 'wSB (pi)' ?
    WSI_PI                            = '265' # 'wSI (pi)' ?
    WSL_PI                            = '266' # 'wSL (pi)' ?
    WXX_PI                            = '267' # 'wXX (pi)' ?
    WCH_C_PI                          = '268' # 'wCH/C (pi)' ?
    WCS_C_PI                          = '269' # 'wCS/C (pi)' ?
    WCU_C_PI                          = '270' # 'wCU/C (pi)' ?
    WFA_C_PI                          = '271' # 'wFA/C (pi)' ?
    WFC_C_PI                          = '272' # 'wFC/C (pi)' ?
    WFS_C_PI                          = '273' # 'wFS/C (pi)' ?
    WKN_C_PI                          = '274' # 'wKN/C (pi)' ?
    WSB_C_PI                          = '275' # 'wSB/C (pi)' ?
    WSI_C_PI                          = '276' # 'wSI/C (pi)' ?
    WSL_C_PI                          = '277' # 'wSL/C (pi)' ?
    WXX_C_PI                          = '278' # 'wXX/C (pi)' ?
    O_SWING_PCT_PI                    = '279' # 'O-Swing% (pi)' ?
    OSWING_PCT_PI                     = O_SWING_PCT_PI
    Z_SWING_PCT_PI                    = '280' # 'Z-Swing% (pi)' ?
    ZSWING_PCT_PI                     = Z_SWING_PCT_PI
    SWING_PCT_PI                      = '281' # 'Swing% (pi)' ?
    O_CONTACT_PCT_PI                  = '282' # 'O-Contact% (pi)' ?
    OCONTACT_PCT_PI                   = O_CONTACT_PCT_PI
    Z_CONTACT_PCT_PI                  = '283' # 'Z-Contact% (pi)' ?
    ZCONTACT_PCT_PI                   = Z_CONTACT_PCT_PI
    CONTACT_PCT_PI                    = '284' # 'Contact% (pi)' ?
    ZONE_PCT_PI                       = '285' # 'Zone% (pi)' ?
    PACE_PI                           = '286' # 'Pace (pi)'?
    FRAMING                           = '287' # ?
    FRM                               = FRAMING
    AVG_PLUS                          = '288' # AVG+ ?
    BB_PCT_PLUS                       = '289' # BB%+ ?
    K_PCT_PLUS                        = '290' # K%+ ?
    OBP_PLUS                          = '291' # OBP+ ?
    SLG_PLUS                          = '292' # SLG+ ?
    ISO_PLUS                          = '293' # ISO+ ?
    BABIP_PLUS                        = '294' # BABIP+ ?
    LD_PCT_PLUS                       = '295' # LD%+ ?
    LD_PLUS_PCT                       = LD_PCT_PLUS
    GB_PCT_PLUS                       = '296' # GB%+ ?
    FB_PCT_PLUS                       = '297' # FB%+ ?
    HR_FB_PCT_PLUS                    = '298' # HR/FB%+ ?
    PULL_PCT_PLUS                     = '299' # Pull%+ ?
    CENT_PCT_PLUS                     = '300' # Cent%+ ?
    OPPO_PCT_PLUS                     = '301' # Oppo%+ ?
    SOFT_PCT_PLUS                     = '302' # Soft%+ ?
    MED_PCT_PLUS                      = '303' # Med %+ ?
    HARD_PCT_PLUS                     = '304' # Hard%+ ?
    EV                                = '305' # ?
    LA                                = '306' # ?
    BARRELS                           = '307' # ?
    BARREL_PCT                        = '308' # Barrel% ?
    MAXEV                             = '309' # maxEV ?
    HARDHIT                           = '310' # ?
    HARDHIT_PCT                       = '311' # HardHit% ?
    EVENTS                            = '312' # ?
    CSTR_PCT                          = '313' # CStr% ?
    CSW_PCT                           = '314' # CSW% ?
    XBA                               = '315' # xBA
    XSLG                              = '316' # xSLG
    XWOBA                             = '317' # xwOBA
    LEGACY_WAR                        = '318' # Legacy WAR
